#!/usr/bin/env python

# david_lum_mask.py
# following the steps described on this link's pdf by david: https://gimplearn.net/viewtopic.php?p=29419#p29419
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
def python_david_lum_mask(image, layer) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_drawable_desaturate(layer_copy,DESATURATE_LUMINANCE)

	#copy Red channel as L1
	channel_L1 = pdb.gimp_channel_new_from_component(image,CHANNEL_RED,"L1")
	pdb.gimp_image_insert_channel(image,channel_L1,None,0)

	#create D1 from Alpha subtract L1
	channel_D1 = pdb.gimp_channel_new_from_component(image,CHANNEL_ALPHA,"D1")
	pdb.gimp_image_insert_channel(image,channel_D1,None,0)
	pdb.gimp_channel_combine_masks(channel_D1,channel_L1,CHANNEL_OP_SUBTRACT,0,0)

	#create DD1 from Alpha - L1 - L1
	channel_DD1 = pdb.gimp_channel_new_from_component(image,CHANNEL_ALPHA,"DD1")
	pdb.gimp_image_insert_channel(image,channel_DD1,None,0)
	pdb.gimp_channel_combine_masks(channel_DD1,channel_L1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_DD1,channel_L1,CHANNEL_OP_SUBTRACT,0,0)

	#create DDD1 from Alpha - L1 - L1 - L1
	channel_DDD1 = pdb.gimp_channel_new_from_component(image,CHANNEL_ALPHA,"DDD1")
	pdb.gimp_image_insert_channel(image,channel_DDD1,None,0)
	pdb.gimp_channel_combine_masks(channel_DDD1,channel_L1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_DDD1,channel_L1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_DDD1,channel_L1,CHANNEL_OP_SUBTRACT,0,0)

	#create DDD from Alpha - L1 - L1 - L1 - L1 
	channel_DDD = pdb.gimp_channel_new_from_component(image,CHANNEL_ALPHA,"DDD")
	pdb.gimp_image_insert_channel(image,channel_DDD,None,0)
	pdb.gimp_channel_combine_masks(channel_DDD,channel_L1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_DDD,channel_L1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_DDD,channel_L1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_DDD,channel_L1,CHANNEL_OP_SUBTRACT,0,0)
	
	#create LL1 from RED_CHANNEL - D1
	channel_LL1 = pdb.gimp_channel_new_from_component(image,CHANNEL_RED,"LL1")
	pdb.gimp_image_insert_channel(image,channel_LL1,None,0)
	pdb.gimp_channel_combine_masks(channel_LL1,channel_D1,CHANNEL_OP_SUBTRACT,0,0)

	#create LLL1 from RED_CHANNEL - D1 -D1 
	channel_LLL1 = pdb.gimp_channel_new_from_component(image,CHANNEL_RED,"LLL1")
	pdb.gimp_image_insert_channel(image,channel_LLL1,None,0)
	pdb.gimp_channel_combine_masks(channel_LLL1,channel_D1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_LLL1,channel_D1,CHANNEL_OP_SUBTRACT,0,0)

	#create LLL from RED_CHANNEL - D1 -D1 -D1 
	channel_LLL = pdb.gimp_channel_new_from_component(image,CHANNEL_RED,"LLL")
	pdb.gimp_image_insert_channel(image,channel_LLL,None,0)
	pdb.gimp_channel_combine_masks(channel_LLL,channel_D1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_LLL,channel_D1,CHANNEL_OP_SUBTRACT,0,0)
	pdb.gimp_channel_combine_masks(channel_LLL,channel_D1,CHANNEL_OP_SUBTRACT,0,0)

	#create M from D1 - DD1
	channel_M = pdb.gimp_channel_copy(channel_D1)
	pdb.gimp_image_insert_channel(image,channel_M,None,0)
	pdb.gimp_item_set_name(channel_M,"M")
	pdb.gimp_channel_combine_masks(channel_M,channel_DD1,CHANNEL_OP_SUBTRACT,0,0)

	#create D from DD1 - DDD1
	channel_D = pdb.gimp_channel_copy(channel_DD1)
	pdb.gimp_image_insert_channel(image,channel_D,None,0)
	pdb.gimp_item_set_name(channel_D,"D")
	pdb.gimp_channel_combine_masks(channel_D,channel_DDD1,CHANNEL_OP_SUBTRACT,0,0)

	#create DD from DDD1 - DDD
	channel_DD = pdb.gimp_channel_copy(channel_DDD1)
	pdb.gimp_image_insert_channel(image,channel_DD,None,0)
	pdb.gimp_item_set_name(channel_DD,"DD")
	pdb.gimp_channel_combine_masks(channel_DD,channel_DDD,CHANNEL_OP_SUBTRACT,0,0)

	#create L from LL1 - LLL1
	channel_L = pdb.gimp_channel_copy(channel_LL1)
	pdb.gimp_image_insert_channel(image,channel_L,None,0)
	pdb.gimp_item_set_name(channel_L,"L")
	pdb.gimp_channel_combine_masks(channel_L,channel_LLL1,CHANNEL_OP_SUBTRACT,0,0)

	#create LL from LLL1 - LLL
	channel_LL = pdb.gimp_channel_copy(channel_LLL1)
	pdb.gimp_image_insert_channel(image,channel_LL,None,0)
	pdb.gimp_item_set_name(channel_LL,"LL")
	pdb.gimp_channel_combine_masks(channel_LL,channel_LLL,CHANNEL_OP_SUBTRACT,0,0)

	pdb.gimp_selection_none(image)
	pdb.gimp_image_remove_layer(image,layer_copy)


	#create layer with DDD as mask
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,channel_DDD)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_item_set_name(layer_copy,"DDD")
	pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	mask = pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	pdb.gimp_layer_add_mask(layer_copy,mask)

	#create layer with DD as mask
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,channel_DD)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_item_set_name(layer_copy,"DD")
	pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	mask = pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	pdb.gimp_layer_add_mask(layer_copy,mask)

	#create layer with D as mask
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,channel_D)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_item_set_name(layer_copy,"D")
	pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	mask = pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	pdb.gimp_layer_add_mask(layer_copy,mask)

	#create layer with M as mask
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,channel_M)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_item_set_name(layer_copy,"M")
	pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	mask = pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	pdb.gimp_layer_add_mask(layer_copy,mask)

	#create layer with L as mask
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,channel_L)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_item_set_name(layer_copy,"L")
	pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	mask = pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	pdb.gimp_layer_add_mask(layer_copy,mask)

	#create layer with LL as mask
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,channel_LL)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_item_set_name(layer_copy,"LL")
	pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	mask = pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	pdb.gimp_layer_add_mask(layer_copy,mask)

	#create layer with LLL as mask
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,channel_LLL)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	pdb.gimp_item_set_name(layer_copy,"LLL")
	pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	mask = pdb.gimp_layer_create_mask(layer_copy,ADD_MASK_SELECTION)
	pdb.gimp_layer_add_mask(layer_copy,mask)

	#remove all channels
	pdb.gimp_image_remove_channel(image,channel_L1)
	pdb.gimp_image_remove_channel(image,channel_LL1)
	pdb.gimp_image_remove_channel(image,channel_LLL1)
	pdb.gimp_image_remove_channel(image,channel_L)
	pdb.gimp_image_remove_channel(image,channel_LL)
	pdb.gimp_image_remove_channel(image,channel_LLL)
	pdb.gimp_image_remove_channel(image,channel_D1)
	pdb.gimp_image_remove_channel(image,channel_DD1)
	pdb.gimp_image_remove_channel(image,channel_DDD1)
	pdb.gimp_image_remove_channel(image,channel_D)
	pdb.gimp_image_remove_channel(image,channel_DD)
	pdb.gimp_image_remove_channel(image,channel_DDD)
	pdb.gimp_image_remove_channel(image,channel_M)

	pdb.gimp_selection_none(image)

	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_fu_david_lum_mask",
	"Create Luminosity Masks",
	"Create Luminosity Masks",
	"Tin Tran",
	"Tin Tran",
	"November 2019",
	"<Image>/Python-Fu/David Luminosity Masks...",             #Menu path
	"RGB*, GRAY*", 
	[
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[],
	python_david_lum_mask)

main()
